/* This file is part of the wvWare 2 project
   Copyright (C) 2001 Werner Trobin <trobin@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef PARSER9X_H
#define PARSER9X_H

namespace wvWare
{

// Word97 so far. Is that different in Word95?
const unsigned char CELL_MARK = 7;
const unsigned char ROW_MARK = 7;
const unsigned char TAB = 9;
const unsigned char HARD_LINE_BREAK = 11;
const unsigned char PAGE_BREAK = 12;
const unsigned char SECTION_MARK = 12;
const unsigned char PARAGRAPH_MARK = 13;
const unsigned char COLUMN_BREAK = 14;
const unsigned char FIELD_BEGIN_MARK = 19;
const unsigned char FIELD_SEPARATOR = 20;
const unsigned char FIELD_END_MARK = 21;
const unsigned char NON_BREAKING_HYPHEN = 30;
const unsigned char NON_REQUIRED_HYPHEN = 31;
const unsigned char SPACE = 32;
const unsigned char BREAKING_HYPHEN = 45;
const unsigned char NON_BREAKING_SPACE = 160;
const unsigned char FIELD_ESCAPE_CHAR = '\\';
const unsigned char FORMULA_MARK = '\\';

// Special chars (fSpec==1)
const unsigned char SPEC_CURRENT_PAGE_NUMBER = 0;
const unsigned char SPEC_PICTURE = 1;
const unsigned char SPEC_AUTONUM_FOOTNOTE_REF = 2;
const unsigned char SPEC_FOOTNOTE_SEPARATOR = 3;
const unsigned char SPEC_FOOTNOTE_CONTINUATION = 4;
const unsigned char SPEC_ANNOTATION_REF = 5;
const unsigned char SPEC_LINE_NUMBER = 6;
const unsigned char SPEC_HAND_ANNOTATION_PIC = 7;
const unsigned char SPEC_DRAWN_OBJECT = 8;
const unsigned char SPEC_ABBREV_DATE = 10;
const unsigned char SPEC_TIME_HMS = 11;
const unsigned char SPEC_CURRENT_SECTION_NUMBER = 12;
const unsigned char SPEC_ABBREV_WEEKDAY = 14;
const unsigned char SPEC_WEEKDAY = 15;
const unsigned char SPEC_DAY_SHORT = 16;
const unsigned char SPEC_CURRENT_HOUR = 22;
const unsigned char SPEC_CURRENT_HOUR_TWODIG = 23;
const unsigned char SPEC_CURRENT_MINUTE = 24;
const unsigned char SPEC_CURRENT_MINUTE_TWODIG = 25;
const unsigned char SPEC_CURRENT_SECONDS = 26;
const unsigned char SPEC_CURRENT_AMPM = 27;
const unsigned char SPEC_CURRENT_TIME_HMS = 28;
const unsigned char SPEC_DATE_M = 29;
const unsigned char SPEC_DATE_SHORT = 30;
const unsigned char SPEC_MONTH_SHORT = 33;
const unsigned char SPEC_YEAR_LONG = 34;
const unsigned char SPEC_YEAR_SHORT = 35;
const unsigned char SPEC_MONTH_ABBREV = 36;
const unsigned char SPEC_MONTH_LONG = 37;
const unsigned char SPEC_CURRENT_TIME_HM = 38;
const unsigned char SPEC_DATE_LONG = 39;
const unsigned char SPEC_MERGE_HELPER = 41;

/**
 * This class should contain all the common functionality shared
 * among the Word9[5|7] parsers. The real parsers inherit privately
 * from this class and override the virtual functions (template
 * method pattern).
 */
class Parser9x
{
public:
    Parser9x();
    virtual ~Parser9x();

    // ###### TODO
};

} // namespace wvWare

#endif // PARSER9X_H
